<template>
  <div>
    <form v-on:submit.prevent="onSubmitStore" ref="form">
      <div class="form-group">
        <p class="form-label">Titre de la demande</p>
        <input class="form-control" type="text" id="help_asked_form_title" name="title" required="required" v-model="title" />
      </div>
      <div class="form-group">
        <p class="form-label">Texte de l'annonce</p>
        <textarea name="content" id="" cols="30" rows="10" class="form-control" v-model="content"></textarea>
      </div>
      <div class="form-group">
        <p class="form-label">Lieu où aider</p>
        <input class="form-control"  type="text" ref="address" id="help_asked_form_address" name="address" @keyup="autosuggest(this)"  required="required" v-model="address" />
        <div class="dropdown">
          <ul ref="list" id="list" class="list-group" >
            <li v-for="item in items" class="list-group-item" @click="addValue(item.position.lat,item.position.lng,item.title)">{{ item.title }}</li>
          </ul>
        </div>
      </div>
      <div class="form-group">
        <p class="form-label">Date souhaitée</p>
        <datetime input-class="form-control" v-model="dateHelp" ref="dateHelp" type="datetime" v-on:input="changeDate" value-zone="local" zone="local"></datetime>
<!--        <vc-calendar v-model="dateHelp" mode="dateTime" :timezone="timezone" @dayclick="changeDate"></vc-calendar>-->
      </div>
      <div>
        <input ref="lat" type="hidden" id="help_asked_form_lat" v-model="lat">
        <input ref="lng" type="hidden" id="help_asked_form_lng" v-model="lng">
      </div>
      <div class="col-md-12 text-center">
        <button class="btn btn-success" type="submit">Envoyer</button>
      </div>
    </form>
  </div>
</template>

<script>
import 'vue-datetime/dist/vue-datetime.css'
export default {
  name: "FormHelp",
  data(){
    return {
      content: '',
      title: '',
      address: '',
      lat: '',
      lng: '',
      dateHelp: '',
      items: [],
      timezone: ''
    }
  },
  methods: {
    autosuggest: function () {

      let searchString = this.$refs.address.value
      if (searchString != "") {
        if (this.items.length > 0)
          this.items = []
        fetch(`https://autosuggest.search.hereapi.com/v1/autosuggest?apiKey=`+HERE_API_KEY+`&at=33.738045,73.084488&limit=5&resultType=city&q=${searchString}&lang=en-US`)
            .then(res => res.json())
            .then((json) => {
              if (json.length != 0) {
                let dropData = json.items.map((item) => {
                  if ((item.position != undefined) & (item.position != ""))
                    this.items.push(item)
                });
              }
            });
      }
    },
    addValue: function(lat, lng, title) {
      this.address =  title;
      this.lat =  lat;
      this.lng =  lng;
      this.items = [];
    },
    changeDate: function() {
      console.log(this.$refs.dateHelp)
    },
    async onSubmitStore() {
      const result = await this.$store.dispatch('help/create', {
        title: this.title,
        content:this.content,
        address: this.address,
        lat: this.lat,
        lng: this.lng,
        dateHelp: this.dateHelp
      })
      if (result !== null) {
        this.$notification.success(result.message)
        this.content = ''
        await this.$store.dispatch('help/findAll')
      }
    }
  }
}
</script>

<style scoped>

</style>